#include <stdbool.h>
#include "processor.h"
#include "fdserial.h"
#include "gcode_struct.h"
#include "StructTest.h"
#include "simpletools.h"

/// cog variables
static int serial_processor_cog = 0;
static int serial_processor_stack[100];

volatile bool gcode_struct_received;
volatile GCODE_STRUCT received_gcode;
volatile char received_struct_array[sizeof(GCODE_STRUCT)];

void serial_processor(void *par);

// start the serial processor
void serial_processor_init()
{
	if(serial_processor_cog == 0)
	{
		serial_processor_cog = 1 + cogstart(&serial_processor, NULL,
			serial_processor_stack, sizeof serial_processor_stack);
	}
}

// stop the serial processor
void serial_processor_stop()
{
	if(serial_processor_cog > 0)
	{
		cogstop(serial_processor_cog - 1);
		serial_processor_cog = 0;
	}
}

void serial_processor(void *par)
{
	uint32_t index;
	fdserial *processor;
	int Char;

	processor = fdserial_open(2, 0, 0, 115200);

	do
	{
		if(fdserial_rxTime(processor, 500) == '<')
		{
			index = 0;

			while((Char = fdserial_rxChar(processor)) && (Char != '>'))
			{
				received_struct_array[index] = Char;
				index++;
			}

			memcpy(&received_gcode, &received_struct_array, sizeof(GCODE_STRUCT));
			memcpy(&sent_gcode, &received_gcode, sizeof(GCODE_STRUCT));
			memset(received_struct_array, 0, sizeof(GCODE_STRUCT));

			gcode_struct_received = true;
		}
	}
  
	while(serial_processor_cog > 0);
}